//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner), s1( 0 ), s2( 0 )
{
  try
  {
    // Utworzenie obiektu dla pierwszej bitmapy
    s1 = new Graphics::TBitmap;
    // Zaladowanie bitmapy z pliku
    s1->LoadFromFile("sphere1.bmp");
    // Ustawienie transparentnosci
    s1->Transparent = true;
    // Kolorem transparentnym bedzie kolor pierwszego piksela
    // s1->TransparentMode = tmAuto;
    s1->TransparentMode = tmFixed;
    // Kolor transparentny pobierany np. pewnego piksela bitmapy
    s1->TransparentColor = s1->Canvas->Pixels[ 0 ][ 0 ];

    // Utworzenie obiektu dla pierwszej bitmapy
    s2 = new Graphics::TBitmap;
    // Zaladowanie bitmapy z pliku
    s2->LoadFromFile("sphere2.bmp");
    // Ustawienie transparentnosci
    s2->Transparent = true;
    // Kolorem transparentnym bedzie wskazany kolor
    s2->TransparentMode = tmFixed;
    // Kolor transparentny pobierany np. pewnego piksela bitmapy
    s2->TransparentColor = s2->Canvas->Pixels[ 0 ][ 0 ];

    InitObjects();
   }
  catch( ... )
  {
    ShowMessage( "Bd obsugi grafiki" );
  }
  randomize();
}

//---------------------------------------------------------------------------
void TForm1::InitObjects()
{
  // Ustalenie wielkosci obszaru "animacyjnego" tla
  bcgRect.Top = 0;
  bcgRect.Left = 0;
  bcgRect.Right =  ClientWidth;
  bcgRect.Bottom = Panel1->Top - 1;

  sprites[ 0 ].pos.x = bcgRect.Right / 2 + 30;
  sprites[ 0 ].pos.y = bcgRect.Bottom / 2;
  sprites[ 0 ].time = sprites[ 0 ].sleepTime = 2;
  sprites[ 0 ].bitmap = s1;

  sprites[ 1 ].pos.x = bcgRect.Right / 2 - 30;
  sprites[ 1 ].pos.y = bcgRect.Bottom / 2;
  sprites[ 1 ].time = sprites[ 1 ].sleepTime = 5;
  sprites[ 1 ].bitmap = s2;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  for( int i = 0; i < NumOfSprites; ++i )
    Canvas->Draw( sprites[i].pos.x, sprites[i].pos.y, sprites[ i ].bitmap ); 
  Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  for( int i = 0; i < NumOfSprites; ++i )
  {
    if( --sprites[ i ].time <= 0 )
    {
      Canvas->Draw( sprites[i].pos.x, sprites[i].pos.y, sprites[ i ].bitmap );
      sprites[ i ].pos.x += random( 5 ) * ( random( 3 ) -  1 );
      sprites[ i ].pos.y += random( 5 ) * ( random( 3 ) -  1 );
      sprites[ i ].time = sprites[ i ].sleepTime;
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  if( s1 != 0 )
    delete s1;
  if( s2 != 0 )
    delete s2;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  Timer1->Enabled = false;        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
  Timer1->Enabled = false;
  InitObjects();
  Canvas->FillRect( bcgRect );
  Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
